# [Difference of Convex](@id DifferenceOfConvexSolvers)

```@meta
CurrentModule = Manopt
```

## [Difference of Convex Algorithm](@id DCASolver)

```@docs
difference_of_convex_algorithm
difference_of_convex_algorithm!
```

## [Difference of Convex Proximal Point](@id DCPPASolver)

```@docs
difference_of_convex_proximal_point
difference_of_convex_proximal_point!
```

## Manopt Solver States

```@docs
DifferenceOfConvexState
DifferenceOfConvexProximalState
```

## The difference of convex objective

```@docs
ManifoldDifferenceOfConvexObjective
```

as well as for the corresponding sub problem

```@docs
LinearizedDCCost
LinearizedDCGrad
```

```@docs
ManifoldDifferenceOfConvexProximalObjective
```

as well as for the corresponding sub problems

```@docs
ProximalDCCost
ProximalDCGrad
```

## Further helper functions

```@docs
get_subtrahend_gradient
```

## Literature

```@bibliography
Pages = ["difference_of_convex.md"]
Canonical=false
```